@ECHO OFF
CLS
TITLE WSS Backup Processing...

REM This script requires 2 executable to be 
REM placed in the SCRIPTPATH folder, these
REM files are: NOW.exe and FORFILES.exe

REM Set Day Variable (Requires NOW.exe from Resource Kit)
  FOR /F "tokens=1" %%F IN ('now') DO SET DAY=%%F
REM Static Variables
  SET BACKUPPATH=C:\TOP\BACKUPS\WSS
  SET SCRIPTPATH=C:\TOP\BACKUPS\WSS
  SET INPUTFILE=SiteList.csv
  SET IISBACKUPFILE=IISBackup%DAY%
  SET LOGFILE=WSSBackup-%DAY%.log
  SET BACKUPRETENTION=2
  SET PATH=%PATH%;%SCRIPTPATH%

  ECHO Processing... Please wait.

REM Starting Log File
  
  NOW **** Starting WSS Backup Processes **** > %BACKUPPATH%\%LOGFILE%

REM Backing up IIS Metabase and purging old Backups

  ECHO. >> %BACKUPPATH%\%LOGFILE%
  IF NOT EXIST "%BACKUPPATH%\IIS_Metabase" md "%BACKUPPATH%\IIS_Metabase"
  NOW Purging Old IIS Backups... >> %BACKUPPATH%\%LOGFILE%
  FORFILES /p %BACKUPPATH%\IIS_Metabase /s /d -3 /c "CMD /C del @file /F /Q" >> %BACKUPPATH%\%LOGFILE% 2>&1

  NOW Backing up IIS Metabase... >> %BACKUPPATH%\%LOGFILE%
  cscript %SYSTEMROOT%\System32\iisback.vbs /backup /b %IISBACKUPFILE% >> %BACKUPPATH%\%LOGFILE%
  ECHO. >> %BACKUPPATH%\%LOGFILE%
  move /Y %SYSTEMROOT%\system32\inetsrv\MetaBack\%IISBACKUPFILE%.* "%BACKUPPATH%\IIS_Metabase" >> %BACKUPPATH%\%LOGFILE%

REM Parsing CSV file located in BACKUPPATH
REM CSV should be in format:
REM CLIENTNAME,CLIENTURL,CLIENTFRIENDLYNAME

FOR /F "tokens=1,2,3 delims=," %%G IN (%BACKUPPATH%\%INPUTFILE%) DO (call :Process %%G %%H %%I)

  :Process

  REM Input parsed as %1 = Client Name, %2 = Client URL, %3 = Friendly Name

  REM Skip blank lines
    IF [%1]==[] GOTO :eof

  ECHO. >> %BACKUPPATH%\%LOGFILE%
  NOW Processing ** %1 ** >> %BACKUPPATH%\%LOGFILE%
  IF NOT EXIST "%BACKUPPATH%\WSS_%1" md "%BACKUPPATH%\WSS_%1" >> %BACKUPPATH%\%LOGFILE%

  NOW Purging the previous backup(s)... >> %BACKUPPATH%\%LOGFILE%
  FORFILES /p "%BACKUPPATH%\WSS_%1" /s /d "-3" /c "CMD /C del @FILE /F /Q" >> %BACKUPPATH%\%LOGFILE% 2>&1

  NOW Performing a Backup of WSS site "%3"... >> %BACKUPPATH%\%LOGFILE%
  "%COMMONPROGRAMFILES%\Microsoft shared\Web server extensions\12\Bin\stsadm" -o backup -url %2 -filename "%BACKUPPATH%\WSS_%1\%DAY%-%3" -overwrite >> %BACKUPPATH%\%LOGFILE%